




function CurrentColorViewModel (viewId, colorChangeDispatcher)
{
	var self = this;
	
	self.viewId = viewId;
	self.element = document.getElementById(viewId);
	
	self.colorChangeDispatcher = colorChangeDispatcher;
    
	self.currentColor = null;
	
	
	// event handler for color selector - we've picked a new color
	self.changeColor = function(event)
    {
    	if (event != null)
		{
	    	// event will be color from color selector
	    	var color = new Color(event.target.value);
	    	
	    	// set name to ""
	    	document.getElementById("currentColorName").value = "";
	    	
	    	// we set the color as the current color
	    	self.currentColor = NamedColor.getNamedColor("", color);
	    	
	    	self.colorChangeDispatcher.broadcastChange(self.currentColor);
		}
    }
    
    
	// event handler for name change only; not a new color, just
	// a name change on underlying NamedColor
    self.changeName = function(event)
    {
    	if (event != null)
		{
    		// event will be name from color name input box
	    	var name = event.target.value;
	    	
	    	// here we react differently - we set the name of the underlying color,
	    	// which will propagate to the displays of that color (buttons, e.g.)
	    	self.currentColor.setName(name);
		}
    }
    
	
	self.onColorChange = function(namedColor)
	{
		self.currentColor = namedColor;
		
		// set current color name in UI
    	var currentColorNameElement = document.getElementById("currentColorName");
    	currentColorNameElement.value = namedColor.name;
    	
    	// set current color name in UI
    	var currentColorElement = document.getElementById("currentColor");
    	currentColorElement.value = namedColor.color.toHexString();
	}
	
	self.colorChangeDispatcher.addChangeListener(self, self.onColorChange);
    
	

}