




//var tileElements = mainSvg.group();

var numRows = Rosette.DEFAULT_NUM_ROWS;
var numCols = Rosette.DEFAULT_NUM_COLUMNS;
var symmetry = Rosette.BOOK_MATCH;
var tileWidth = Rosette.DEFAULT_TILE_WIDTH;
var tileHeight = Rosette.DEFAULT_TILE_WIDTH;
var radius = Rosette.DEFAULT_RADIUS;

var backColor = Tile.DEFAULT_BACKGROUND_COLOR;
var gridColor = Tile.DEFAULT_GRID_COLOR;

var rosette = new Rosette(numRows, numCols, symmetry, tileWidth, tileHeight, radius, backColor, gridColor);

var colorChangeDispatcher = new ChangeDispatcher();


var svg = Snap("#svgWindow");
//var displayScale = RosetteViewModel.DEFAULT_DISPLAY_SCALE;
var displayScale = 96;

var rosetteViewModel = new RosetteViewModel(svg, rosette, displayScale, colorChangeDispatcher);

var currentColorViewModel = new CurrentColorViewModel("ColorChangePanel", colorChangeDispatcher);

// current colors now done through palette manager
//var currentColorsViewModel = new PaletteViewModel("ColorButtonDiv", colorChangeDispatcher);
//currentColorsViewModel.setAutoAddColors(true);

var paletteManagerViewModel = new PaletteManagerViewModel("PaletteManagerView", colorChangeDispatcher);


// Knockout bindings
ko.applyBindings(rosetteViewModel, $("#svgPanel")[0]);
ko.applyBindings(rosetteViewModel, $("#CopyColorDiv")[0]);
ko.applyBindings(rosetteViewModel, $("#SymmetryPanel")[0]);
ko.applyBindings(rosetteViewModel, $("#RowColumnPanel")[0]);
ko.applyBindings(rosetteViewModel, $("#DimensionsPanel")[0]);
ko.applyBindings(rosetteViewModel, $("#ShiftPanel")[0]);
ko.applyBindings(rosetteViewModel, $("#RingPanel")[0]);
ko.applyBindings(rosetteViewModel, $("#NavBar")[0]);

ko.applyBindings(currentColorViewModel, $("#CurrentColorSelectorDiv")[0]);

// tie together interacting display parts with dispatcher
//colorChangeDispatcher.addChangeListener(rosetteViewModel, rosetteViewModel.onColorChange);
//colorChangeDispatcher.addChangeListener(currentColorViewModel, currentColorViewModel.onColorChange);

// add a reference to the dispatcher to each of the listeners so they can broadcast
//rosetteViewModel.colorChangeDispatcher = colorChangeDispatcher;
//currentColorViewModel.colorChangeDispatcher = colorChangeDispatcher;

// use so palette manager can register palettes with dispatcher
//paletteManagerViewModel.colorChangeDispatcher = colorChangeDispatcher;

// rosette view model getting color change info from two panels
//currentColorViewModel.addColorChangeListener(rosetteViewModel);
//currentColorsViewModel.addColorChangeListener(rosetteViewModel);

// selectors getting info from each other
//currentColorViewModel.addColorChangeListener(currentColorsViewModel);
//currentColorsViewModel.addColorChangeListener(currentColorViewModel);

//set initial color rosette view model - dispatcher will pass it to others
var initialColor = NamedColor.getNamedColor("Black", new Color("#000000"));
rosetteViewModel.setCurrentColor(initialColor);


rosetteViewModel.drawRosette(displayScale);


// top-level handlers




/*
var openRosetteElement = document.getElementById('openRosette');
openRosetteElement.addEventListener('change', openRosette);
		
function openRosette(event)
{
	
	var file = event.target.files[0];
    var fileReader = new FileReader();
    fileReader.onload = function(event){rosetteViewModel.setRosetteFromXml(event.target.result);};
    
    // set cursor to wait... doesn't work while Javascript runs...
	document.body.style.cursor = "wait";
	
    fileReader.readAsText(file);
    
    // set cursor to default
	document.body.style.cursor = "default";
	
	
};

var saveRosetteElement = document.getElementById('saveRosette');
saveRosetteElement.addEventListener('click', saveRosette);
		
function saveRosette(event)
{
	var xmlString = vkbeautify.xml(rosetteViewModel.generateXmlString());
	var blob = new Blob([xmlString], {type: "text/plain;charset=utf-8"});
	saveAs(blob, "test.xml");
};
*/

// Utility function
function getDescendantById(element, id)
{
    for (var i = 0; i < element.children.length; i++) 
    {
        var child = element.children[i];
        if (child.id == id)
        {
            return child;
        }
        else
        {
            var descendant = self.getDescendantById(child, id);
            if (descendant != null)
            {
                return descendant;
            }
        }
    }
    
    // not found
    return null;
};


function getChildById(element, id)
{
    for (var i = 0; i < element.children.length; i++) 
    {
        var child = element.children[i];
        if (child.id == id)
        {
            return child;
        }
    }
    
    // not found
    return null;
};







